/* Copyright (C) 2006 Imperial College London and others.
   
   Please see the AUTHORS file in the main source directory for a full list
   of copyright holders.
   
   Dr Gerard J Gorman
   Applied Modelling and Computation Group
   Department of Earth Science and Engineering
   Imperial College London
   
   g.gorman@imperial.ac.uk
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
   USA
*/
#ifndef VTU_SAM_H
#define VTU_SAM_H

#include "confdefs.h"

#include <map>
#include <string>
#include <vector>

#include <vtk.h>

#include "c++debug.h"
#include "Mesh.h"
#include "samtypes.h"

void sam_init(vtkUnstructuredGrid *ug, int NPrivateNodes, std::vector<int> &SENList, std::vector<int> &sids);
void sam_migrate(bool diffusion);
vtkUnstructuredGrid *sam_export_mesh(int &NPrivateNodes, std::vector<int> &SENList, std::vector<int> &sids);
void sam_cleanup();

// "Mesh" is the principle object that does everything for SAM.
extern Mesh *mesh;
extern std::vector<int> decomp_opts;

#endif
